﻿using System.IO;

namespace JunctionNET.Win32
{
    enum IOControlCode : uint
    {
        // FileAccess.Any = 0

        // STORAGE
        StorageCheckVerify = (DeviceType.MassStorage << 16) | (0x0200 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        StorageCheckVerify2 = (DeviceType.MassStorage << 16) | (0x0200 << 2) | IOMethod.Buffered | (0 << 14),
        StorageMediaRemoval = (DeviceType.MassStorage << 16) | (0x0201 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        StorageEjectMedia = (DeviceType.MassStorage << 16) | (0x0202 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        StorageLoadMedia = (DeviceType.MassStorage << 16) | (0x0203 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        StorageLoadMedia2 = (DeviceType.MassStorage << 16) | (0x0203 << 2) | IOMethod.Buffered | (0 << 14),
        StorageReserve = (DeviceType.MassStorage << 16) | (0x0204 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        StorageRelease = (DeviceType.MassStorage << 16) | (0x0205 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        StorageFindNewDevices = (DeviceType.MassStorage << 16) | (0x0206 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        StorageEjectionControl = (DeviceType.MassStorage << 16) | (0x0250 << 2) | IOMethod.Buffered | (0 << 14),
        StorageMcnControl = (DeviceType.MassStorage << 16) | (0x0251 << 2) | IOMethod.Buffered | (0 << 14),
        StorageGetMediaTypes = (DeviceType.MassStorage << 16) | (0x0300 << 2) | IOMethod.Buffered | (0 << 14),
        StorageGetMediaTypesEx = (DeviceType.MassStorage << 16) | (0x0301 << 2) | IOMethod.Buffered | (0 << 14),
        StorageResetBus = (DeviceType.MassStorage << 16) | (0x0400 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        StorageResetDevice = (DeviceType.MassStorage << 16) | (0x0401 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        StorageGetDeviceNumber = (DeviceType.MassStorage << 16) | (0x0420 << 2) | IOMethod.Buffered | (0 << 14),
        StoragePredictFailure = (DeviceType.MassStorage << 16) | (0x0440 << 2) | IOMethod.Buffered | (0 << 14),
        StorageObsoleteResetBus = (DeviceType.MassStorage << 16) | (0x0400 << 2) | IOMethod.Buffered | (FileAccess.ReadWrite << 14),
        StorageObsoleteResetDevice = (DeviceType.MassStorage << 16) | (0x0401 << 2) | IOMethod.Buffered | (FileAccess.ReadWrite << 14),
        StorageQueryProperty = (DeviceType.MassStorage << 16) | (0x0500 << 2) | IOMethod.Buffered | (0 << 14),

        // DISK
        DiskGetDriveGeometry = (DeviceType.Disk << 16) | (0x0000 << 2) | IOMethod.Buffered | (0 << 14),
        DiskGetDriveGeometryEx = (DeviceType.Disk << 16) | (0x0028 << 2) | IOMethod.Buffered | (0 << 14),
        DiskGetPartitionInfo = (DeviceType.Disk << 16) | (0x0001 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        DiskGetPartitionInfoEx = (DeviceType.Disk << 16) | (0x0012 << 2) | IOMethod.Buffered | (0 << 14),
        DiskSetPartitionInfo = (DeviceType.Disk << 16) | (0x0002 << 2) | IOMethod.Buffered | (FileAccess.ReadWrite << 14),
        DiskGetDriveLayout = (DeviceType.Disk << 16) | (0x0003 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        DiskSetDriveLayout = (DeviceType.Disk << 16) | (0x0004 << 2) | IOMethod.Buffered | (FileAccess.ReadWrite << 14),
        DiskVerify = (DeviceType.Disk << 16) | (0x0005 << 2) | IOMethod.Buffered | (0 << 14),
        DiskFormatTracks = (DeviceType.Disk << 16) | (0x0006 << 2) | IOMethod.Buffered | (FileAccess.ReadWrite << 14),
        DiskReassignBlocks = (DeviceType.Disk << 16) | (0x0007 << 2) | IOMethod.Buffered | (FileAccess.ReadWrite << 14),
        DiskPerformance = (DeviceType.Disk << 16) | (0x0008 << 2) | IOMethod.Buffered | (0 << 14),
        DiskIsWritable = (DeviceType.Disk << 16) | (0x0009 << 2) | IOMethod.Buffered | (0 << 14),
        DiskLogging = (DeviceType.Disk << 16) | (0x000a << 2) | IOMethod.Buffered | (0 << 14),
        DiskFormatTracksEx = (DeviceType.Disk << 16) | (0x000b << 2) | IOMethod.Buffered | (FileAccess.ReadWrite << 14),
        DiskHistogramStructure = (DeviceType.Disk << 16) | (0x000c << 2) | IOMethod.Buffered | (0 << 14),
        DiskHistogramData = (DeviceType.Disk << 16) | (0x000d << 2) | IOMethod.Buffered | (0 << 14),
        DiskHistogramReset = (DeviceType.Disk << 16) | (0x000e << 2) | IOMethod.Buffered | (0 << 14),
        DiskRequestStructure = (DeviceType.Disk << 16) | (0x000f << 2) | IOMethod.Buffered | (0 << 14),
        DiskRequestData = (DeviceType.Disk << 16) | (0x0010 << 2) | IOMethod.Buffered | (0 << 14),
        DiskControllerNumber = (DeviceType.Disk << 16) | (0x0011 << 2) | IOMethod.Buffered | (0 << 14),
        DiskSmartGetVersion = (DeviceType.Disk << 16) | (0x0020 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        DiskSmartSendDriveCommand = (DeviceType.Disk << 16) | (0x0021 << 2) | IOMethod.Buffered | (FileAccess.ReadWrite << 14),
        DiskSmartRcvDriveData = (DeviceType.Disk << 16) | (0x0022 << 2) | IOMethod.Buffered | (FileAccess.ReadWrite << 14),
        DiskUpdateDriveSize = (DeviceType.Disk << 16) | (0x0032 << 2) | IOMethod.Buffered | (FileAccess.ReadWrite << 14),
        DiskGrowPartition = (DeviceType.Disk << 16) | (0x0034 << 2) | IOMethod.Buffered | (FileAccess.ReadWrite << 14),
        DiskGetCacheInformation = (DeviceType.Disk << 16) | (0x0035 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        DiskSetCacheInformation = (DeviceType.Disk << 16) | (0x0036 << 2) | IOMethod.Buffered | (FileAccess.ReadWrite << 14),
        DiskDeleteDriveLayout = (DeviceType.Disk << 16) | (0x0040 << 2) | IOMethod.Buffered | (FileAccess.ReadWrite << 14),
        DiskFormatDrive = (DeviceType.Disk << 16) | (0x00f3 << 2) | IOMethod.Buffered | (FileAccess.ReadWrite << 14),
        DiskSenseDevice = (DeviceType.Disk << 16) | (0x00f8 << 2) | IOMethod.Buffered | (0 << 14),
        DiskCheckVerify = (DeviceType.Disk << 16) | (0x0200 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        DiskMediaRemoval = (DeviceType.Disk << 16) | (0x0201 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        DiskEjectMedia = (DeviceType.Disk << 16) | (0x0202 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        DiskLoadMedia = (DeviceType.Disk << 16) | (0x0203 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        DiskReserve = (DeviceType.Disk << 16) | (0x0204 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        DiskRelease = (DeviceType.Disk << 16) | (0x0205 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        DiskFindNewDevices = (DeviceType.Disk << 16) | (0x0206 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        DiskGetMediaTypes = (DeviceType.Disk << 16) | (0x0300 << 2) | IOMethod.Buffered | (0 << 14),
        DiskSetPartitionInfoEx = (DeviceType.Disk << 16) | (0x0013 << 2) | IOMethod.Buffered | (FileAccess.ReadWrite << 14),
        DiskGetDriveLayoutEx = (DeviceType.Disk << 16) | (0x0014 << 2) | IOMethod.Buffered | (0 << 14),
        DiskSetDriveLayoutEx = (DeviceType.Disk << 16) | (0x0015 << 2) | IOMethod.Buffered | (FileAccess.ReadWrite << 14),
        DiskCreateDisk = (DeviceType.Disk << 16) | (0x0016 << 2) | IOMethod.Buffered | (FileAccess.ReadWrite << 14),
        DiskGetLengthInfo = (DeviceType.Disk << 16) | (0x0017 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),

        // CHANGER
        ChangerGetParameters = (DeviceType.Changer << 16) | (0x0000 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        ChangerGetStatus = (DeviceType.Changer << 16) | (0x0001 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        ChangerGetProductData = (DeviceType.Changer << 16) | (0x0002 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        ChangerSetAccess = (DeviceType.Changer << 16) | (0x0004 << 2) | IOMethod.Buffered | (FileAccess.ReadWrite << 14),
        ChangerGetElementStatus = (DeviceType.Changer << 16) | (0x0005 << 2) | IOMethod.Buffered | (FileAccess.ReadWrite << 14),
        ChangerInitializeElementStatus = (DeviceType.Changer << 16) | (0x0006 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        ChangerSetPosition = (DeviceType.Changer << 16) | (0x0007 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        ChangerExchangeMedium = (DeviceType.Changer << 16) | (0x0008 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        ChangerMoveMedium = (DeviceType.Changer << 16) | (0x0009 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        ChangerReinitializeTarget = (DeviceType.Changer << 16) | (0x000A << 2) | IOMethod.Buffered | (FileAccess.Read << 14),
        ChangerQueryVolumeTags = (DeviceType.Changer << 16) | (0x000B << 2) | IOMethod.Buffered | (FileAccess.ReadWrite << 14),

        // FILESYSTEM
        FsctlRequestOplockLevel1 = (DeviceType.FileSystem << 16) | (0 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlRequestOplockLevel2 = (DeviceType.FileSystem << 16) | (1 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlRequestBatchOplock = (DeviceType.FileSystem << 16) | (2 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlOplockBreakAcknowledge = (DeviceType.FileSystem << 16) | (3 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlOpBatchAckClosePending = (DeviceType.FileSystem << 16) | (4 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlOplockBreakNotify = (DeviceType.FileSystem << 16) | (5 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlLockVolume = (DeviceType.FileSystem << 16) | (6 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlUnlockVolume = (DeviceType.FileSystem << 16) | (7 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlDismountVolume = (DeviceType.FileSystem << 16) | (8 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlIsVolumeMounted = (DeviceType.FileSystem << 16) | (10 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlIsPathnameValid = (DeviceType.FileSystem << 16) | (11 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlMarkVolumeDirty = (DeviceType.FileSystem << 16) | (12 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlQueryRetrievalPointers = (DeviceType.FileSystem << 16) | (14 << 2) | IOMethod.Neither | (0 << 14),
        FsctlGetCompression = (DeviceType.FileSystem << 16) | (15 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlSetCompression = (DeviceType.FileSystem << 16) | (16 << 2) | IOMethod.Buffered | (FileAccess.ReadWrite << 14),
        FsctlMarkAsSystemHive = (DeviceType.FileSystem << 16) | (19 << 2) | IOMethod.Neither | (0 << 14),
        FsctlOplockBreakAckNo2 = (DeviceType.FileSystem << 16) | (20 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlInvalidateVolumes = (DeviceType.FileSystem << 16) | (21 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlQueryFatBpb = (DeviceType.FileSystem << 16) | (22 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlRequestFilterOplock = (DeviceType.FileSystem << 16) | (23 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlFileSystemGetStatistics = (DeviceType.FileSystem << 16) | (24 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlGetNtfsVolumeData = (DeviceType.FileSystem << 16) | (25 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlGetNtfsFileRecord = (DeviceType.FileSystem << 16) | (26 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlGetVolumeBitmap = (DeviceType.FileSystem << 16) | (27 << 2) | IOMethod.Neither | (0 << 14),
        FsctlGetRetrievalPointers = (DeviceType.FileSystem << 16) | (28 << 2) | IOMethod.Neither | (0 << 14),
        FsctlMoveFile = (DeviceType.FileSystem << 16) | (29 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlIsVolumeDirty = (DeviceType.FileSystem << 16) | (30 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlGetHfsInformation = (DeviceType.FileSystem << 16) | (31 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlAllowExtendedDasdIo = (DeviceType.FileSystem << 16) | (32 << 2) | IOMethod.Neither | (0 << 14),
        FsctlReadPropertyData = (DeviceType.FileSystem << 16) | (33 << 2) | IOMethod.Neither | (0 << 14),
        FsctlWritePropertyData = (DeviceType.FileSystem << 16) | (34 << 2) | IOMethod.Neither | (0 << 14),
        FsctlFindFilesBySid = (DeviceType.FileSystem << 16) | (35 << 2) | IOMethod.Neither | (0 << 14),
        FsctlDumpPropertyData = (DeviceType.FileSystem << 16) | (37 << 2) | IOMethod.Neither | (0 << 14),
        FsctlSetObjectId = (DeviceType.FileSystem << 16) | (38 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlGetObjectId = (DeviceType.FileSystem << 16) | (39 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlDeleteObjectId = (DeviceType.FileSystem << 16) | (40 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlSetReparsePoint = (DeviceType.FileSystem << 16) | (41 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlGetReparsePoint = (DeviceType.FileSystem << 16) | (42 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlDeleteReparsePoint = (DeviceType.FileSystem << 16) | (43 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlEnumUsnData = (DeviceType.FileSystem << 16) | (44 << 2) | IOMethod.Neither | (0 << 14),
        FsctlSecurityIdCheck = (DeviceType.FileSystem << 16) | (45 << 2) | IOMethod.Neither | (FileAccess.Read << 14),
        FsctlReadUsnJournal = (DeviceType.FileSystem << 16) | (46 << 2) | IOMethod.Neither | (0 << 14),
        FsctlSetObjectIdExtended = (DeviceType.FileSystem << 16) | (47 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlCreateOrGetObjectId = (DeviceType.FileSystem << 16) | (48 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlSetSparse = (DeviceType.FileSystem << 16) | (49 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlSetZeroData = (DeviceType.FileSystem << 16) | (50 << 2) | IOMethod.Buffered | (FileAccess.Write << 14),
        FsctlQueryAllocatedRanges = (DeviceType.FileSystem << 16) | (51 << 2) | IOMethod.Neither | (FileAccess.Read << 14),
        FsctlEnableUpgrade = (DeviceType.FileSystem << 16) | (52 << 2) | IOMethod.Buffered | (FileAccess.Write << 14),
        FsctlSetEncryption = (DeviceType.FileSystem << 16) | (53 << 2) | IOMethod.Neither | (0 << 14),
        FsctlEncryptionFsctlIo = (DeviceType.FileSystem << 16) | (54 << 2) | IOMethod.Neither | (0 << 14),
        FsctlWriteRawEncrypted = (DeviceType.FileSystem << 16) | (55 << 2) | IOMethod.Neither | (0 << 14),
        FsctlReadRawEncrypted = (DeviceType.FileSystem << 16) | (56 << 2) | IOMethod.Neither | (0 << 14),
        FsctlCreateUsnJournal = (DeviceType.FileSystem << 16) | (57 << 2) | IOMethod.Neither | (0 << 14),
        FsctlReadFileUsnData = (DeviceType.FileSystem << 16) | (58 << 2) | IOMethod.Neither | (0 << 14),
        FsctlWriteUsnCloseRecord = (DeviceType.FileSystem << 16) | (59 << 2) | IOMethod.Neither | (0 << 14),
        FsctlExtendVolume = (DeviceType.FileSystem << 16) | (60 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlQueryUsnJournal = (DeviceType.FileSystem << 16) | (61 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlDeleteUsnJournal = (DeviceType.FileSystem << 16) | (62 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlMarkHandle = (DeviceType.FileSystem << 16) | (63 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlSisCopyFile = (DeviceType.FileSystem << 16) | (64 << 2) | IOMethod.Buffered | (0 << 14),
        FsctlSisLinkFiles = (DeviceType.FileSystem << 16) | (65 << 2) | IOMethod.Buffered | (FileAccess.ReadWrite << 14),
        FsctlHsmMsg = (DeviceType.FileSystem << 16) | (66 << 2) | IOMethod.Buffered | (FileAccess.ReadWrite << 14),
        FsctlNssControl = (DeviceType.FileSystem << 16) | (67 << 2) | IOMethod.Buffered | (FileAccess.Write << 14),
        FsctlHsmData = (DeviceType.FileSystem << 16) | (68 << 2) | IOMethod.Neither | (FileAccess.ReadWrite << 14),
        FsctlRecallFile = (DeviceType.FileSystem << 16) | (69 << 2) | IOMethod.Neither | (0 << 14),
        FsctlNssRcontrol = (DeviceType.FileSystem << 16) | (70 << 2) | IOMethod.Buffered | (FileAccess.Read << 14),

        // VIDEO
        VideoQuerySupportedBrightness = (DeviceType.Video << 16) | (0x0125 << 2) | IOMethod.Buffered | (0 << 14),
        VideoQueryDisplayBrightness = (DeviceType.Video << 16) | (0x0126 << 2) | IOMethod.Buffered | (0 << 14),
        VideoSetDisplayBrightness = (DeviceType.Video << 16) | (0x0127 << 2) | IOMethod.Buffered | (0 << 14),
    }
}
